      *=====================================================================*
      *  WSDL2RPG: WDSL Operation                                           *
      *=====================================================================*
      *  Author  :  Thomas Raddatz                                          *
      *  Date    :  06.11.2007                                              *
      *  E-mail  :  thomas.raddatz@Tools400.de                              *
      *  Homepage:  www.tools400.de                                         *
      *=====================================================================*
      *                                                                     *
      *  This software is free software, you can redistribute it and/or     *
      *  modify it under the terms of the GNU General Public License (GPL)  *
      *  as published by the Free Software Foundation.                      *
      *                                                                     *
      *  See GNU General Public License for details.                        *
      *          http://www.opensource.org                                  *
      *          http://www.opensource.org/licenses/gpl-license.html        *
      *                                                                     *
      *=====================================================================*
      *  History:                                                           *
      *                                                                     *
      *  Date        Name          Description                              *
      *  ----------  ------------  ---------------------------------------  *
      *  28.05.2008  Th.Raddatz    Replaces QName_toString() with           *
      *                            QName_getKey().                          *
      *                                                                     *
      *  31.10.2008  Th.Raddatz    Replaced import 'g_hTypes' by procedure  *
      *                            call to Controller_getGlobalTypesList(). *
      *                                                                     *
      *  08.01.2009  Th.Raddatz    Changed changeMessageToRpcStyle() to     *
      *                            use TypeDef_produceName() to create a    *
      *                            unique RPC name.                         *
      *                                                                     *
      *  09.01.2009  Th.Raddatz    Changed suffix of RPC return value       *
      *                            from 'Response' to 'Rpc'.                *
      *                                                                     *
      *  24.06.2009  Th.Raddatz    Changed changeMessageToRpcStyle() to     *
      *                            also change the request message.         *
      *                                                                     *
      *  25.10.2010  Th.Raddatz    Added procedure                          *
      *                            Operation_getVisualizedTypeStructure().  *
      *                                                                     *
      *  05.02.2011  Th.Raddatz    Parameter Structure Visualizer:          *
      *                            Now correctly respecting the sequence of *
      *                            the parts of the request message.        *
      *                            (See fix from 31.01.2011 in WSDL2R01)    *
      *                                                                     *
      *  26.03.2012  Th.Raddatz    Changed changeMessageToRpcStyle() to use *
      *                            'tmpNewPart' instead of 'tmpPart' because*
      *                            'tmpPart' is based on a pointer!         *
      *                                                                     *
      *  10.10.2012  Th.Raddatz    Added Operation_getParameterOrderList(). *
      *                            Removed Operation_getParameterOrder().   *
      *                            Changed Operation_changeToRpcStyle() to  *
      *                            also change the request message to RPC   *
      *                            style. That way we get a structure with  *
      *                            all parts of the request message.        *
      *                                                                     *
      *  19.09.2013  Th.Raddatz    Fixed and reactivated the detection of   *
      *                            element recursions.                      *
      *                                                                     *
      *  10.06.2015  Th.Raddatz    Fixed "Invalid handle" (USR0034) message *
      *                            in procedure changeMessageToRpcStyle().  *
      *                                                                     *
      *=====================================================================*
      *   >>PRE-COMPILER<<                                                  *
      *                                                                     *
      *     >>CRTCMD<<  CRTRPGMOD   MODULE(&LI/&OB) +                       *
      *                             SRCFILE(&SL/&SF) +                      *
      *                             SRCMBR(&SM);                            *
      *                                                                     *
      *     >>COMPILE<<                                                     *
      *       >>PARM<< TRUNCNBR(*NO);                                       *
      *       >>PARM<< DBGVIEW(*LIST);                                      *
      *       >>PARM<< TGTRLS(V6R1M0  );                                    *
      *     >>END-COMPILE<<                                                 *
      *                                                                     *
      *     >>EXECUTE<<                                                     *
      *                                                                     *
      *   >>END-PRE-COMPILER<<                                              *
      *=====================================================================*
 CPY H NOMAIN
      /COPY QWSDL2RPG,H_SPEC
      *=====================================================================*
      *
      * ------------------------------------
      *  Constants
      * ------------------------------------
      *
      * ------------------------------------
      *  Type Definitions
      * ------------------------------------
      /COPY QWSDL2RPG,TYPES
      *
      * ------------------------------------
      *  Exported prototypes
      * ------------------------------------
      /COPY QWSDL2RPG,PWSDL2R52
      *
      * ------------------------------------
      *  Imported prototypes
      * ------------------------------------
      /COPY QBASICS1,PBASICS1                      Tools/400 Runtime Library
      /COPY QLOG4RPG,PLOG4RPG                      Log4rpg
      *
      /COPY QWSDL2RPG,CLIB                         C Runtime Library
      *
      /COPY QWSDL2RPG,PWSDL2R01                    WSDL2RPG: Main / Controller
      /COPY QWSDL2RPG,PWSDL2R50                    WSDL2RPG: WDSL Type
      /COPY QWSDL2RPG,PWSDL2R53                    WSDL2RPG: WDSL Message
      /COPY QWSDL2RPG,PWSDL2R54                    WSDL2RPG: WSDL Part
      /COPY QWSDL2RPG,PWSDL2R61                    WSDL2RPG: WSDL OperationIO
      /COPY QWSDL2RPG,PWSDL2R91                    WSDL2RPG: QName
      /COPY QWSDL2RPG,PWSDL2R92                    WSDL2RPG: UnMarshaller/Marshaller Helper
      /COPY QWSDL2RPG,PWSDL2R95                    WSDL2RPG: RpgType
      *
      * ------------------------------------
      *  Internal prototypes
      * ------------------------------------
      *
      *  Adds the operation name as a type to a message.
     D changeMessageToRpcStyle...
     D                 PR
     D                                     extproc('changeMessageToRpcStyle')
     D  i_operation                        const  likeds(wsdl_operation_t)
     D  i_pMessage                     *   const
     D  i_suffix                     64A   const  varying
      *
      *  Returns the visualized structure of a given type.
     D visualizeType...
     D                 PR                  extproc('visualizeType')
     D  i_hList                            const  like(BasicList_handle_t )
     D  i_entryType                        const  like(visualized...
     D                                                 Type_t.entryType)
     D  i_prefix                      2A   const  varying
     D  i_type                             const  likeds(wsdl_type_t      )
     D  i_level                      10I 0 const
     D  i_part                             const  like(wsdl_part_t        )
     D                                            options(*nopass)
      *
      *  Initializes this module.
     D initializeModule...
     D                 PR
     D                                     extproc('initializeModule')
      *
      * ------------------------------------
      *  Global fields & constants
      * ------------------------------------
     D g_isInit        S               N   inz(cFalse)
      *
     D g_hLogger       S                   like(LOG4RPG_hLogger_t)
     D g_hLoggerVT     S                   like(LOG4RPG_hLogger_t)
      *
     D g_recursion...
     D                 DS                  qualified
     D  hMap                               like(BasicMap_handle_t   ) inz
      *
      * ------------------------------------
      *  Program Status Data Structure
      * ------------------------------------
      /DEFINE SDS_EXTENDED
      /COPY QWSDL2RPG,SDS
      /UNDEFINE SDS_EXTENDED
      *
      *=====================================================================*
      *  Returns a new operation.
      *=====================================================================*
     P Operation_new...
     P                 B                   export
      *
     D Operation_new...
     D                 PI                         likeds(wsdl_operation_t   )
     D  i_name                             const  like(wsdl_name_t      )
     D  i_parameterOrder...
     D                                     const  like(wsdl_parameterOrder_t)
     D                                            options(*nopass)
      *
      *  Return value
     D operation       DS                  likeds(wsdl_operation_t  ) inz
      *
      *  Parameter positions
     D p_parameterOrder...
     D                 C                   2
      *
      *  Fields for optional parameters
     D parameterOrder  S                   like(i_parameterOrder ) inz
      * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      /FREE

         // Get optional parameter values ...
         // ... parameterOrder
         if (%parms() >= p_parameterOrder);
            parameterOrder = i_parameterOrder;
         else;
            parameterOrder = '';
         endif;

         clear operation;
         operation.isUsed = cFalse;
         operation.qName  = QName_newName(i_name);
         operation.parameterOrder = parameterOrder;
         operation.documentation  = '';
         operation.input  = OperationIO_null();
         operation.output = OperationIO_null();

         return operation;

      /END-FREE
      *
     P Operation_new...
     P                 E
      *
      *=====================================================================*
      *  Returns the key of a given operation.
      *=====================================================================*
     P Operation_getKey...
     P                 B                   export
      *
     D Operation_getKey...
     D                 PI                         like(wsdl_mapKey_t     )
     D  i_operation                        const  likeds(wsdl_operation_t)
      * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      /FREE

         return QName_getKey(i_operation.qName);

      /END-FREE
      *
     P Operation_getKey...
     P                 E
      *
      *=====================================================================*
      *  Returns the key to retrieve the associated bound operation.
      *=====================================================================*
     P Operation_getBoundOperationKey...
     P                 B                   export
      *
     D Operation_getBoundOperationKey...
     D                 PI                         like(wsdl_mapKey_t     )
     D  i_operation                        const  likeds(wsdl_operation_t)
      * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      /FREE

         return QName_getKey(i_operation.qName);

      /END-FREE
      *
     P Operation_getBoundOperationKey...
     P                 E
      *
      *=====================================================================*
      *  Type helper:
      *  Returns the qualified name of a given operation.
      *=====================================================================*
     P Operation_getQName...
     P                 B                   export
      *
     D Operation_getQName...
     D                 PI                         likeds(wsdl_qName_t)
     D  i_operation                        const  likeds(wsdl_operation_t  )
      * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      /FREE

         return i_operation.qName;

      /END-FREE
      *
     P Operation_getQName...
     P                 E
      *
      *=====================================================================*
      *  Sets the documentation of a given operation.
      *=====================================================================*
     P Operation_setDocumentation...
     P                 B                   export
      *
     D Operation_setDocumentation...
     D                 PI
     D  io_operation                              likeds(wsdl_operation_t)
     D  i_documentation...
     D                                     const  like(wsdl_documentation_t)
      * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      /FREE

         io_operation.documentation = i_documentation;

         return;

      /END-FREE
      *
     P Operation_setDocumentation...
     P                 E
      *
      *=====================================================================*
      *  Returns the documenation of a given operation.
      *=====================================================================*
     P Operation_getDocumentation...
     P                 B                   export
      *
     D Operation_getDocumentation...
     D                 PI                         like(wsdl_documentation_t)
     D  i_operation                        const  likeds(wsdl_operation_t  )
      * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      /FREE

         return i_operation.documentation;

      /END-FREE
      *
     P Operation_getDocumentation...
     P                 E
      *
      *=====================================================================*
      *  Returns the parameter order of a given operation.
      *=====================================================================*
     P Operation_getParameterOrderList...
     P                 B                   export
      *
     D Operation_getParameterOrderList...
     D                 PI                         like(BasicList_handle_t   )
     D  i_operation                        const  likeds(wsdl_operation_t   )
      *
      *  Return value
     D hParmOrder      S                   like(BasicList_handle_t ) inz
      *
      *  Local fields
     D pToken          S               *   inz
     D parameter       S                   like(wsdl_name_t   ) inz
      * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      /FREE

         if (i_operation.parameterOrder <> '');
            hParmOrder = BasicList_new('');
            pToken = strtok(i_operation.parameterOrder: ' ');
            dou (pToken = *NULL);
               parameter = %str(pToken);
               BasicList_addString(hParmOrder: parameter);
               pToken = strtok(*NULL: ' ');
            enddo;
         else;
            hParmOrder = BasicList_null();
         endif;

         return hParmOrder;

      /END-FREE
      *
     P Operation_getParameterOrderList...
     P                 E
      *
      *=====================================================================*
      *  Returns the request message of a given operation.
      *=====================================================================*
     P Operation_getRequestMessage...
     P                 B                   export
      *
     D Operation_getRequestMessage...
     D                 PI                         likeds(wsdl_message_t  )
     D  i_operation                        const  likeds(wsdl_operation_t)
      *
      *  Return value
     D requestMsg      DS                  likeds(wsdl_message_t ) inz
      *
      *  Local fields
     D tmpMessage      DS                  likeds(wsdl_message_t ) inz
      * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      /FREE

         initializeModule();

         Logger_debug(g_hLogger:
                      'Retrieving operation request message ...');

         OperationIO_getMessage(i_operation.input: tmpMessage);
         if (not Message_isNull(tmpMessage));
            requestMsg = tmpMessage;
            Logger_debug(g_hLogger:
                         '... the selected message is: ' +
                              QName_toString(requestMsg.qName));
         else;
            requestMsg = Message_null();
            Logger_error(g_hLogger:
                         '... the request message could not be found!');
         endif;

         return requestMsg;

      /END-FREE
      *
     P Operation_getRequestMessage...
     P                 E
      *
      *=====================================================================*
      *  Returns the response message of a given operation.
      *=====================================================================*
     P Operation_getResponseMessage...
     P                 B                   export
      *
     D Operation_getResponseMessage...
     D                 PI                         likeds(wsdl_message_t  )
     D  i_operation                        const  likeds(wsdl_operation_t)
      *
      *  Return value
     D responseMsg     DS                  likeds(wsdl_message_t ) inz
      *
      *  Local fields
     D tmpMessage      DS                  likeds(wsdl_message_t ) inz
      * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      /FREE

         initializeModule();

         Logger_debug(g_hLogger:
                      'Retrieving operation response message ...');

         OperationIO_getMessage(i_operation.output: tmpMessage);
         if (not Message_isNull(tmpMessage));
            responseMsg = tmpMessage;
            Logger_debug(g_hLogger:
                         '... the selected message is: ' +
                              QName_toString(responseMsg.qName));
         else;
            responseMsg = Message_null();
            Logger_error(g_hLogger:
                         '... the response message could not be found!');
         endif;

         return responseMsg;

      /END-FREE
      *
     P Operation_getResponseMessage...
     P                 E
      *
      *=====================================================================*
      *  Adds a type with the operation to the request and response types.
      *  (Necessary for 'rpc' encoded style)
      *=====================================================================*
     P Operation_changeToRpcStyle...
     P                 B                   export
      *
     D Operation_changeToRpcStyle...
     D                 PI
     D  i_operation                        const  likeds(wsdl_operation_t)
      *
      *  Local fields
     D x               S             10I 0 inz
     D pMessage        S               *   inz
     D respMessage     DS                  likeds(wsdl_message_t ) inz
     D reqMessage      DS                  likeds(wsdl_message_t ) inz
     D part            DS                  likeds(wsdl_part_t    )
     D                                     based(pPart)
      * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      /FREE

         initializeModule();

         respMessage = Operation_getResponseMessage(i_operation);
         if (not Message_isNull(respMessage));

            Logger_debug(g_hLogger:
                         'Changing operation response message +
                          to ''rpc'' style ...');

            pMessage = Controller_getMessage(Message_getQName(respMessage));

            changeMessageToRpcStyle(
                  i_operation: pMessage: cGENERATOR_RPC_RESPONSE_NAME_SUFFIX);

            Logger_debug(g_hLogger:
                         '... operation response message +
                          changed to ''rpc'' style ...');
         endif;

         // -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -

         Logger_debug(g_hLogger:
                      'Changing operation request message +
                       to ''rpc'' style ...');

         pMessage = Controller_getMessage(
                       Message_getQName(
                          Operation_getRequestMessage(i_operation)));

         changeMessageToRpcStyle(
               i_operation: pMessage: '');

         Logger_debug(g_hLogger:
                      '... operation request message +
                       changed to ''rpc'' style ...');
         return;

         reqMessage = Operation_getRequestMessage(i_operation);

         if (BasicMap_isNull(reqMessage.partsList.hMap));
            Logger_debug(g_hLogger:
                         '--> No parts found');
            return;
         endif;

         for x = 1 to BasicMap_getNumE(reqMessage.partsList.hMap);
            pPart = BasicMap_getValueByIndex(reqMessage.partsList.hMap: x);
            if (Part_isPrimitive(part));
               Part_changeToUserDefined(part);
            endif;
         endfor;

         Logger_debug(g_hLogger:
                      '... operation request message +
                       changed to ''rpc'' style ...');

         return;

      /END-FREE
      *
     P Operation_changeToRpcStyle...
     P                 E
      *
      *=====================================================================*
    R *  *** private ***
      *  Adds the operation name as a type to a message.
      *=====================================================================*
     P changeMessageToRpcStyle...
     P                 B
      *
     D changeMessageToRpcStyle...
     D                 PI
     D  i_operation                        const  likeds(wsdl_operation_t)
     D  i_pMessage                     *   const
     D  i_suffix                     64A   const  varying
      *
      *  Local fields
     D x               S             10I 0 inz
     D p               S             10I 0 inz
     D s               S             10I 0 inz
     D hParmOrder      S                   like(BasicList_handle_t ) inz
     D parameter       S                   like(wsdl_name_t        ) inz
     D hPartsList      S                   like(BasicList_handle_t ) inz
      *
     D hPartsMap       S                   like(BasicMap_handle_t) inz
     D tmpMessage      DS                  likeds(wsdl_message_t )
     D                                     based(pTmpMessage)
     D tmpPart         DS                  likeds(wsdl_part_t    )
     D                                     based(pTmpPart)
     D rpcType         DS                  likeds(wsdl_type_t    ) inz
     D tmpType         DS                  likeds(wsdl_type_t    ) inz
     D tmpQName        DS                  likeds(wsdl_qName_t   ) inz
     D tmpNewPart      DS                  likeds(wsdl_part_t    ) inz
      *
      *  Global types list
     D hGlobalTypes    S                   like(BasicMap_handle_t) inz
      * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      /FREE

         initializeModule();

         hGlobalTypes = Controller_getGlobalTypesList();

         // Get message
         pTmpMessage = i_pMessage;

         // Create 'rpc' type from operation name
         tmpQName = TypeDef_produceName(
                                Operation_getQName(i_operation): i_suffix);
         rpcType = TypeDef_newType(QName_toXml(tmpQName): '');
         TypeDef_setQualified(rpcType: cTrue);

         // Add original types to new 'rpc' type
         if (Message_hasParts(tmpMessage));
            TypeDef_setIsSequence(rpcType: cTrue);

            // hParmOrder = Operation_getParameterOrderList(i_operation);
            hParmOrder = BasicList_null();   // TODO: ParameterOrder

            p = 1;
            s = 0;
            hPartsList = Message_getParts(tmpMessage);

            dou (BasicList_isNull(hParmOrder) or
                 p > BasicList_getNumE(hParmOrder));

               for x = 1 to BasicList_getNumE(hPartsList);
                  pTmpPart = BasicList_get(hPartsList: x);

                  if (not BasicList_isNull(hParmOrder) and
                      p <= BasicList_getNumE(hParmOrder));
                     parameter = BasicList_getString(hParmOrder: p);
                     if (parameter <> QName_getLName(Part_getQName(tmpPart)));
                        iter;
                     endif;
                  endif;

                  if (Part_isPrimitive(tmpPart));
                     Part_changeToUserDefined(tmpPart);
                  endif;
                  Part_getType(tmpPart: tmpType);
                  s = s + 1;
                  tmpType = TypeDef_newElement(
                               QName_toXml(Part_getQName(tmpPart))
                             : QName_toXml(TypeDef_getQName(tmpType))
                             : s);
                  TypeDef_addSubType(rpcType: tmpType);
                  Message_removePart(tmpMessage: tmpPart);
               endfor;

               // Get next parameter from parameter order list
               p = p + 1;
            enddo;

            BasicList_delete(hPartsList);

            if (not BasicList_isNull(hParmOrder));
               BasicList_delete(hParmOrder);
            endif;
         endif;

         // Add new 'rpc' to global types map
         BasicMap_put(hGlobalTypes
                      : TypeDef_getKey(rpcType)
                      : %addr(rpcType)
                      : %size(rpcType));

         // Create new message part for the name of the operation
         // and add it to the message
         tmpNewPart = Part_newType(Operation_toXml(i_operation) + i_suffix
                                   : TypeDef_toXml(rpcType));

         Message_addPart(tmpMessage: tmpNewPart);

         return;

      /END-FREE
      *
     P changeMessageToRpcStyle...
     P                 E
      *
      *=====================================================================*
      *  Returns the visualized structure of the request
      *  and response parameters of a given operation.
      *=====================================================================*
     P Operation_getVisualizedTypeStructure...
     P                 B                   export
      *
     D Operation_getVisualizedTypeStructure...
     D                 PI                         like(BasicList_handle_t )
     D  i_operation                        const  likeds(wsdl_operation_t)
      *
      *  Return value
     D pList           S                   like(BasicList_handle_t )
      *
      *  Helper fields
     D x               S             10I 0 inz
     D p               S             10I 0 inz
     D reqMessage      DS                  likeds(wsdl_message_t   ) inz
     D respMessage     DS                  likeds(wsdl_message_t   ) inz
     D pToken          S               *   inz
     D hParmOrder      S                   like(BasicList_handle_t ) inz
     D parameter       S                   like(wsdl_name_t   ) inz
     D hPartsList      S                   like(BasicList_handle_t ) inz
     D part            DS                  likeds(wsdl_part_t )
     D                                     based(pPart)
     D type            DS                  likeds(wsdl_type_t )
     D                                     based(pType)
      * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      /FREE

         pList = BasicList_new();

         // --------------------------------------------------
         //    Visualize Request Parameters
         // --------------------------------------------------
         Logger_warn(g_hLoggerVT
                     : 'Producing visualized structure of request message ..');

         reqMessage = Operation_getRequestMessage(i_operation);
         if (not Message_hasParts(reqMessage));
            return pList;
         endif;

         g_recursion.hMap = BasicMap_new();

         // Build parameter order list
         if (i_operation.parameterOrder <> '');
            hParmOrder = BasicList_new('');
            pToken = strtok(i_operation.parameterOrder: ' ');
            dou (pToken = *NULL);
               parameter = %str(pToken);
               BasicList_addString(hParmOrder: parameter);
               pToken = strtok(*NULL: ' ');
            enddo;
         else;
            hParmOrder = BasicList_null();
         endif;

         // Spin through parameter order and generate the input parameters
         p = 1;
         hPartsList = Message_getParts(reqMessage);

         dou (BasicList_isNull(hParmOrder) or
              p > BasicList_getNumE(hParmOrder));

            for x = 1 to BasicList_getNumE(hPartsList);
               pPart = BasicList_get(hPartsList: x);

               if (not BasicList_isNull(hParmOrder) and
                   p <= BasicList_getNumE(hParmOrder));
                  parameter = BasicList_getString(hParmOrder: p);
                  if (parameter <> part.qName.lName);
                     iter;
                  endif;
               else;
                  parameter = '';
               endif;

               pType = Part_getType(part);
               if (not TypeDef_isDefined(type));
                  iter;
               endif;

               if (parameter <> '');
                  Logger_warn(g_hLoggerVT: 'Parameter: ' + %char(p));
               else;
                  Logger_warn(g_hLoggerVT: 'Parameter: ' + %char(x));
               endif;

               visualizeType(pList: cENTRY_TYPE_REQUEST_MESSAGE
                             : 'i_': type: 1: part);
            endfor;

            // Get next parameter from parameter order list
            p = p + 1;
         enddo;

         BasicList_delete(hPartsList);

         if (not BasicList_isNull(hParmOrder));
            BasicList_delete(hParmOrder);
         endif;

         p_assert(BasicMap_getNumE(g_recursion.hMap) = 0);

         // --------------------------------------------------
         //    Visualize Response Parameters
         // --------------------------------------------------
         Logger_warn(g_hLoggerVT
                     : 'Producing visualized structure of response message ..');

         respMessage = Operation_getResponseMessage(i_operation);
         if (BasicMap_isNull(respMessage.partsList.hMap));
            if (not BasicMap_isNull(g_recursion.hMap));
               BasicMap_delete(g_recursion.hMap);
            endif;
            return pList;
         endif;

         for x = 1 to BasicMap_getNumE(respMessage.partsList.hMap);
            pPart = BasicMap_getValueByIndex(respMessage.partsList.hMap: x);

            pType = Part_getType(part);
            if (not TypeDef_isDefined(type));
               iter;
            endif;

            Logger_warn(g_hLoggerVT
                        : 'Parameter: ' + %char(x));
            visualizeType(pList: cENTRY_TYPE_RESPONSE_MESSAGE
                          : 'o_': type: 1: part);
         endfor;

         if (not BasicMap_isNull(g_recursion.hMap));
            BasicMap_delete(g_recursion.hMap);
         endif;

         return pList;

      /END-FREE
      *
     P Operation_getVisualizedTypeStructure...
     P                 E
      *
      *=====================================================================*
      *  Returns the visualized structure of a given type.
      *=====================================================================*
     P visualizeType...
     P                 B
      *
     D visualizeType...
     D                 PI
     D  i_hList                            const  like(BasicList_handle_t )
     D  i_entryType                        const  like(visualized...
     D                                                 Type_t.entryType)
     D  i_prefix                      2A   const  varying
     D  i_type                             const  likeds(wsdl_type_t      )
     D  i_level                      10I 0 const
     D  i_part                             const  like(wsdl_part_t        )
     D                                            options(*nopass)
      *
      *  Helper fields
     D x               S             10I 0 inz
     D parmName        S                   like(wsdl_name_t        ) inz
     D hChildren       S                   like(BasicList_handle_t ) inz
     D uuid            S             16A   inz
     D theType         DS                  likeds(wsdl_type_t      ) inz
     D aChild          DS                  likeds(wsdl_type_t      ) inz
     D rpgType         DS                  likeds(wsdl_rpgType_t   ) inz
      *
      *  ParameterVisualizer List Entry
     D visualizedType  DS                  likeds(visualizedType_t ) inz
      * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      /FREE

         clear visualizedType;
         visualizedType.entryType = i_entryType;
         visualizedType.level     = i_level;

         if (i_level = 1);
            if (Controller_isRpcStyle());
               parmName = QName_getSimpleFieldName(Part_getQName(i_part));
               visualizedType.name = i_prefix + parmName;
            else;
               visualizedType.name =
                     i_prefix + QName_getFieldName(TypeDef_getQName(i_type));
            endif;
         else;
            visualizedType.name =
                  QName_getSubFieldName(TypeDef_getQName(i_type));
         endif;

         if (TypeDef_isArrayValue(i_type));
            if (Controller_isDynamicList());
               visualizedType.extTypeInf = cEXT_TYPE_INF_DYNAMIC_ARRAY;
            else;
               visualizedType.extTypeInf = cEXT_TYPE_INF_STATIC_ARRAY;
            endif;
         else;
            if (TypeDef_isArrayIndex(i_type));
               visualizedType.extTypeInf = cEXT_TYPE_INF_ARRAY_INDEX;
            endif;
         endif;

         if (TypeDef_isPrimitive(i_type));
            visualizedType.rpgType = UnMarshaller_getRpgType(i_type);
         else;
            visualizedType.rpgType = RpgType_new();
            if (TypeDef_isUserDefined(i_type));
               visualizedType.rpgType.refField =
                     QName_getRefFieldName(TypeDef_getQType(i_type));
            else;
               visualizedType.rpgType.refField =
                     QName_getRefFieldName(TypeDef_getQName(i_type));
            endif;
         endif;

         theType = i_type;
         dow (TypeDef_isUserDefined(theType));
            BasicMap_get(Controller_getGlobalTypesList()
                         : TypeDef_getRefTypeKey(theType)
                         : %addr(theType)
                         : %size(theType));
         enddo;

         Logger_warn(g_hLoggerVT
                     : f_space(visualizedType.level*2) +
                       %char(visualizedType.level) +
                       ': ' + visualizedType.name +
                       ' (' + RpgType_toString(visualizedType.rpgType) + ' / ' +
                              visualizedType.extTypeInf + ')');

         uuid = TypeDef_getUUID(theType);
         if (BasicMap_containsKey(g_recursion.hMap: uuid));
            visualizedType.extTypeInf = cEXT_TYPE_INF_RECURSION;
            BasicList_add(i_hList: %addr(visualizedType):%size(visualizedType));
            return;
         else;
            BasicMap_putString(g_recursion.hMap: uuid: '');
         endif;

         BasicList_add(i_hList: %addr(visualizedType): %size(visualizedType));

         if (TypeDef_hasChildren(theType));
            hChildren = TypeDef_getChildren(theType);
            for x = 1 to BasicList_getNumE(hChildren);
               BasicList_get(hChildren: x: %addr(aChild): %size(aChild));
               visualizeType(i_hList: i_entryType: '': aChild: i_level + 1);
            endfor;
            BasicList_delete(hChildren);
         endif;

         BasicMap_remove(g_recursion.hMap: uuid);

         return;

      /END-FREE
      *
     P visualizeType...
     P                 E
      *
      *=====================================================================*
      *  Returns a given operation as 'string'.
      *=====================================================================*
     P Operation_toString...
     P                 B                   export
      *
     D Operation_toString...
     D                 PI                         like(wsdl_name_t       )
     D  i_operation                        const  likeds(wsdl_operation_t)
      * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      /FREE

         return QName_toString(i_operation.qName);

      /END-FREE
      *
     P Operation_toString...
     P                 E
      *
      *=====================================================================*
      *  Returns a given operation as a XML compliant string.
      *=====================================================================*
     P Operation_toXml...
     P                 B                   export
      *
     D Operation_toXml...
     D                 PI                         like(wsdl_name_t        )
     D  i_operation                        const  likeds(wsdl_operation_t )
      *
      *  Return value
     D xmlString       S                   like(wsdl_name_t ) inz
      * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      /FREE

         xmlString = QName_toXml(Operation_getQName(i_operation));

         return xmlString;

      /END-FREE
      *
     P Operation_toXml...
     P                 E
      *
      *=====================================================================*
      *  Returns cTrue if a operation is NULL.
      *=====================================================================*
     P Operation_isNull...
     P                 B                   export
      *
     D Operation_isNull...
     D                 PI              N
     D  i_operation                        const  likeds(wsdl_operation_t)
      * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      /FREE

         if (i_operation = Operation_null());
            return cTrue;
         else;
            return cFalse;
         endif;

      /END-FREE
      *
     P Operation_isNull...
     P                 E
      *
      *=====================================================================*
      *  Returns a NULL operation.
      *=====================================================================*
     P Operation_null...
     P                 B                   export
      *
     D Operation_null...
     D                 PI                         likeds(wsdl_operation_t)
      *
      *  Return value
     D operation       DS                  likeds(wsdl_operation_t) inz
      * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      /FREE

         clear operation;

         return operation;

      /END-FREE
      *
     P Operation_null...
     P                 E
      *
      *=====================================================================*
      *  Initializes this module.
      *=====================================================================*
     P initializeModule...
     P                 B
      *
     D initializeModule...
     D                 PI
      * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      /FREE

         if (g_isInit);
            return;
         endif;

         g_hLogger   = Logger_getLogger(cLOGGER +
                                        cLOGGER_OPERATION);
         g_hLoggerVT = Logger_getLogger(cLOGGER +
                                        cLOGGER_OPERATION_VISUALIZED_TYPES);

         g_isInit = cTrue;

      /END-FREE
      *
     P initializeModule...
     P                 E
      *
